#include "Complex.h"
#include <cmath>
#include <iostream>
using namespace std;

Complex::Complex(string var, int re, int im) {
	this->re = re;
	this->im = im;
	this->var = var;
}

void Complex::fetchName(string z, int& i) {
	var = ""; 
	// Vrtimo se kroz for petlju dok ne dodjemo do '=' jer nam to oznacava da smo stigli do kraja imena
	for (i = 0; i < z.length() && z[i] != '='; i++) {
		if (z[i] == ' ') continue; // opciono preskacemo razmake
		var += z[i];			   // svaki karakter dodajemo u ime nase promenljive jedan po jedan
	}
	// Na poziciji 'i' ce se naci znak '=', a posto nam taj znak nije od interesa, kao povratnu vrednost vracamo sledecu poziciju u stringu
	i++;
}

// Metoda koja preskace razmake
void Complex::skipSpaces(string z, int& i) {
	for (; i < z.length() && z[i] == ' '; i++);
}

void Complex::fetchReal(string z, int& i) {
	bool minus = false;
	skipSpaces(z, i);
	// Opciono pre realnog dela kompleksnog broja moze da dodje znak '-' pa proveravamo tu situaciju
	if (z[i] == '-') {
		minus = true; i++;
	}
	skipSpaces(z, i);
	re = 0;
	// Nasli znak minus ili ne, sledece sto citamo je broj
	for (; i < z.length() && z[i] <= '9' && z[i] >= '0'; i++) {
		if (z[i] == ' ') continue;
		// U svakoj iteraciji dodajemo novu cifru na realan deo broja tako sto trenutni broj mnozimo sa 10 i dodajemo novu cifru
		re = re * 10 + (z[i] - '0'); // z[k] - '0' vraca cifru u int formatu
	}
	// Ako smo prethodno naisli na minus, menjamo znak realnog dela
	if (minus) re = -re;
	// Ukoliko nakon broja naidjemo na znak 'i', to znaci da realan deo nije ni postojao, nego smo zapravo procitali imaginaran deo
	if (z[i] == 'i' && re != 0) {
		im = re; re = 0;
	}
	else if (z[i] == 'i' && re == 0) {
		im = (minus == true) ? -1 : 1; 
		re = 0;
	}
} 

void Complex::fetchImag(string z, int& i) {
	// Metoda koja cita imaginarni deo kompleksnog broja je slicna kao i metoda koja cita realan deo broja
	bool minus = false;
	skipSpaces(z, i);
	if (z[i] == '-') {
		minus = true; i++;
	}
	else if (z[i] == '+') {
		i++;
	}
	skipSpaces(z, i);
	im = 0;
	for (; i < z.length() && z[i] <= '9' && z[i] >= '0'; i++) {
		if (z[i] == ' ') continue;
		im = im * 10 + (z[i] - '0');
	}
	if (im == 0 && z[i] == 'i') im = 1;
	if (minus) im = -im;
}

Complex::Complex(string z) {
	int i = 0; re = im = 0; var = "";
	// Vrsimo algoritamsku dekompoziciju i delimo parsiranje ovog stringa na nekoliko delova (ucitavanje promenljive, ucitavanje realnog dela i ucitavanje imaginarnog dela)
	// Svaka od ovih metoda kao parametar prima string i poziciju do koje je stigla sa citanjem stringa, a kao povratnu vrednost vracaju poziciju do koje su stigli sa citanjem stringa da bi sledeca metoda mogla da koristi tu poziciju
	fetchName(z, i);
	fetchReal(z, i);
	// Posto postoji mogucnost da metoda fetchReal procita imaginarni deo broja, prvo proveravamo da li ima smisla pozivati metodu fetchImag
	if(i < z.length() - 1) fetchImag(z, i);
}

void Complex::print() {
	cout << var << " = ";
	if (re == 0 && im == 0) cout << "0";
	if (re != 0) cout << re;
	if (im == 1 || im == -1) cout << (im > 0 && re != 0 ? "+" : "") << (im == 1 ? "i" : "-i");
	else if (im != 0) cout << (im > 0 && re != 0 ? "+" : "") << im << "i";
	cout << endl;
}

Complex* Complex::add(string var, Complex* other) {
	int re, im;
	re = this->re + other->re;
	im = this->im + other->im;
	return new Complex(var, re, im);
}

Complex* Complex::sub(string var, Complex* other) {
	int re, im;
	re = this->re - other->re;
	im = this->im - other->im;
	return new Complex(var, re, im);
}
